/*************************************************************

	PIC16F648ApL[{[hERg[
	CCS C Compiler PCM ver 3.249 ɂăRpCEmF

	LKEY24`/Ȃ
	fR[_12L[p̃R[h܂̓fR[_t24L[p̃R[h
	ł悤ɂĂ܂B

	܂AUSEWDT`/Ȃ
	X[vԂ̕AEHb`EhbOE^C}ōs
	O1gz̃pXōsIł܂B

**************************************************************/
#include    <16f648a.h>
//#define	USEWDT	//EHb`EhbOE^C}pƂ͂̒`Lɂ
//#define	KEY24	//̒`ĂȂƂ12L[pifR[_j

#ifdef	KEY24
#define	TOPROW	0
#define	MAXROW	4
#else
#define	TOPROW	0x40
#define	MAXROW	2
#endif

#ifdef	USEWDT
#fuses INTRC_IO,WDT,NOPROTECT,PUT,NOBROWNOUT,MCLR,NOCPD,NOLVP 
#else
#fuses INTRC_IO,NOWDT,NOPROTECT,PUT,NOBROWNOUT,MCLR,NOCPD,NOLVP 
#endif
#use delay(CLOCK = 4000000)		//clock 4MHz
#use fast_io(A)
#use fast_io(B)

#define	SLEEP_TIME	6000		//X[vԂɂȂ܂ł̎ԁ@1/100b

int16		sleep_counter;
unsigned char	kbctr,kbdata;
char	keybuf[4],kflag;

#ifdef	USEWDT
#else
#INT_EXT
void isr_ext(void)	//O荞
{
	//X[vԂ̕Ap
}
#endif

#INT_TIMER0
void isr_t0(void)	//^C}0荞
{
	unsigned	char	d,s,n;
	char	*kp;


	set_timer0(256 - 39);			//^C}0Đݒ@10msecɊ荞ݔ
	if(sleep_counter != 0)
		sleep_counter--;
	kp = keybuf;
	s = TOPROW;
	for(n = 0; n < MAXROW; n++){//L[̏Ԃ`FbN
		output_b(s | (input_b() & 0x3f));
		d = input_a() & 0x5f;
		if(d != 0x5f && d == *kp){
			kflag++;
			if(kflag == 100){	//1bԉꂽ
				kflag = 80;		//0.2bɃs[go
				kbctr = 1;
				if(d & 0x40)
					d |= 0x20;
				d &= 0x3f;
				d |= s;
				kbdata = d;
				goto k_exit;
			}
			if(kflag == 3){
				kbctr = 1;
				if(d & 0x40)//rbg̕ёւ
					d |= 0x20;
				d &= 0x3f;
				d |= s;
				kbdata = d;
			}
			goto k_exit;
		}
		*kp = d;
		kp++;
		s += 0x40;
	}
	kflag = 0;
	k_exit:
	output_b(0xc0 | input_b());
}

void wait_key_break(void)	//X[vԂ畜AƂ̃L[̏Ԃ`FbN
{
	unsigned	char	d,s,n;
	char	*kp;

	disable_interrupts(INT_TIMER0);
	output_b(0x3f);
	#ifdef	USEWDT
	#else
	enable_interrupts(INT_EXT);
	#endif
	for( ; ; ){
		#ifdef	USEWDT
		setup_wdt(WDT_1152MS);
		restart_wdt();
		#endif
		sleep();

		kp = keybuf;//X[vԂ畜AƂL[͂Ȃ΃X[vԂɖ߂
		s = TOPROW;
		for(n = 0; n < MAXROW; n++){//L[̏Ԃ`FbN
			output_b(s | (input_b() & 0x3f));
			d = input_a() & 0x5f;
			if(d != 0x5f && d == *kp){
				kflag++;
				goto wkb_exit;
			}
			*kp = d;
			kp++;
			s += 0x40;
		}
		kflag = 0;
		wkb_exit:
		output_b(0xc0 | input_b());
		if(kflag == 2)//ꂩ̃L[ĂX[vԂɂ͖߂Ȃ
			break;
	}
	#ifdef	USEWDT
	#else
	disable_interrupts(INT_EXT);
	#endif
	setup_timer_0(RTCC_INTERNAL | RTCC_DIV_256);
	set_timer0(256 - 39);
	enable_interrupts(GLOBAL | INT_TIMER0);
}

void main()
{
	char	n,mask,d;

	setup_oscillator(OSC_4MHZ);
	#ifdef	USEWDT
	restart_wdt();
	setup_wdt(WDT_1152MS);
	#endif
	setup_comparator (NC_NC_NC_NC);
	set_tris_a(0x7F);	// 7:STB o, 6,4-0: L[̏ԓ
	set_tris_b(0x01);	// 7,6:L[̃XLMo 5-1:R[ho 0:INT 
	output_bit(PIN_A7,1);	//strobe = H

	sleep_counter = SLEEP_TIME;
	setup_timer_0(RTCC_INTERNAL | RTCC_DIV_256);
	set_timer0(256 - 39);
	enable_interrupts(GLOBAL | INT_TIMER0);
	for( ; ; ){
		#ifdef	USEWDT
		restart_wdt();
		#endif
		if(kbctr){
			kbctr = 0;
			mask = 1;	//rbg`FbN̂߂̃}XNf[^
			for(n = 0; n < 6; n++){
				if((mask & kbdata) == 0){
					d = n;
					break;
				}		
				mask <<= 1;
			}
			kbdata &= 0xc0;
			#ifdef	KEY24
			switch(kbdata){
				case 0x00:
					break;	//0,1,2,3,4,5
				case 0x40:
					d += 6;	//6,7,8,9,10,11
					break;
				case 0x80:
					d += 12;//12,13,14,15,16,17
					break;
				default:
					d += 18;//18,19,20,21,22,23
					break;
			}
			#else
			if(kbdata == 0x80)
				d += 6;//6,7,8,9,10,11
			#endif
			d <<= 1;	//PB1kra
			disable_interrupts(GLOBAL);
			output_b(d | (input_b() & 0xc0));
			enable_interrupts(GLOBAL);
			output_bit(PIN_A7,0);	//strobe = L
			delay_ms(1);			//pulse width
			output_bit(PIN_A7,1);	//strobe = H
			sleep_counter = SLEEP_TIME;
		}
		if(sleep_counter == 0){
			if(input_b() & 1)//INTiPB0j[q'L'ɂĂƃX[vԂɂ͂ȂȂ
				wait_key_break();
			sleep_counter = SLEEP_TIME;
		}
	}
}
